/* EMACS_MODES: c,fill=0 */
typedef	struct	Symbol {		/* symbol table entry */
	char	*name;
	short	type;			/* VAR, BLTIN, UNDEF */
	union {
		double	val;		/* if VAR */
		double	(*ptr)();	/* if BLTIN */
		int	(*defn)();	/* FUNCTION, PROCEDURE */
		char	*str;		/* string */
	} u;
	struct	Symbol	*next;		/* link to next */
} Symbol;
Symbol	*install(), *lookup();

typedef	union	Datum {			/* interpreter stack type */
	double	val;
	Symbol	*sym;
} Datum;

typedef	int	(*Inst)();		/* machine instruction */
#define	STOP	(Inst) 0
#define	LATER	(Inst) 0

extern	Datum	pop();
extern	Inst	prog[], *progp, *code(), *progbase;
extern	eval(), add(), sub(), mul(), div(), negate(), power(),
	assign(), bltin(), varpush(), constpush(),
	print(), prexpr(), prstr(),
	gt(), lt(), eq(), ge(), le(), ne(), and(), or(), not(),
	ifcode(), whilecode(), varread(), call(), arg(), argassign(),
	funcret(), procret();
