%{

/*
 *			**** CALC ****
 *
 * This routine will function like a desk calculator
 * There are 26 integer registers, named 'a' thru 'z'
 *
 */
	/* begin specs */
#include <stdio.h>
#include <ctype.h>

int regs[26];
int base, debugsw;

extern int yyerror();

%}

%start list

%token DIGIT LETTER WHITESP

%left '|'
%left '&'
%left '+' '-'
%left '*' '/' '%'
%left UMINUS

%%	/* end specs, begin rules */

list	:	/* empty */
	|	list stat '\n'
	|	list error '\n'
			{ yyerrok; }
	;

stat	:	expr
			{ printf("%d\n", $1); }
	|	LETTER '=' expr
			{ regs[$1] = $3; }
	;

expr	:	'(' expr ')'
			{ $$ = $2; }
	|	expr '-' expr
			{ $$ = $1 - $3; }
	|	expr '+' expr
			{ $$ = $1 + $3; }
	|	expr '*' expr
			{ $$ = $1 * $3; }
	|	expr '/' expr
			{ $$ = $1 / $3; }
	|	expr '%' expr
			{ $$ = $1 % $3; }
	|	expr '&' expr
			{ $$ = $1 & $3; }
	|	expr '|' expr
			{ $$ = $1 | $3; }
	|	expr '-' expr	%prec UMINUS
			{ $$ = -$2; }
	|	LETTER
			{ $$ = regs[$1]; }
	|	number
	;

number	:	DIGIT
			{ $$ = $1; base = ($1 == 0) ? 8 : 10; }
	|	number DIGIT
			{ $$ = base * $1 + $2; }
	;

whitesp:	WHITESP
	;

%%	/* end of rules, start of program */

#include "lex.yy.c"
